
using MonoDevelop.XmlEditor;
using NUnit.Framework;
using System;

namespace MonoDevelop.XmlEditor.Tests
{
	/// <summary>
	/// Tests that the mime types "text/xml" and
	/// "application/xml" are handled by the 
	/// XmlEditorViewContent.
	/// </summary>
	[TestFixture]
	public class MimeTypeHandledTests
	{
		[Test]
		public void IsTextXmlHandled()
		{
			Assert.IsTrue(XmlEditorViewContent.IsMimeTypeHandled("text/xml"));
		}
		
		[Test]
		public void IsApplicationXmlHandled()
		{
			Assert.IsTrue(XmlEditorViewContent.IsMimeTypeHandled("application/xml"));
		}	
		
		[Test]
		public void NullMimeTypeIsNotHandled()
		{
			Assert.IsFalse(XmlEditorViewContent.IsMimeTypeHandled(null));
		}	

		[Test]
		public void IsUnknownMimeTypeHandled()
		{
			Assert.IsFalse(XmlEditorViewContent.IsMimeTypeHandled("unknown/xml"));
		}		
	}
}
